rb_vm_struct Struct Reference

`#include <vm_core.h>`

## Data Fields

VALUE | self
rb_global_vm_lock_t | gvl
struct rb_thread_struct * | main_thread
struct rb_thread_struct * | running_thread
st_table * | living_threads
VALUE | thgroup_default
int | running
int | inhibit_thread_creation
int | thread_abort_on_exception
unsigned long | trace_flag
volatile int | sleeper
VALUE | mark_object_ary
VALUE | special_exceptions [ruby_special_error_count]
VALUE | top_self
VALUE | load_path
VALUE | loaded_features
struct st_table * | loading_table
struct {
VALUE cmd
int safe
} | trap_list [RUBY_NSIG]
rb_event_hook_t * | event_hooks
int | src_encoding_index
VALUE | verbose
VALUE | debug
VALUE | progname
VALUE | coverages
struct unlinked_method_entry_list_entry * | unlinked_method_entry_list
struct rb_objspace * | objspace
struct RArray | at_exit

## Detailed Description

Definition at line 276 of file vm_core.h.

## Field Documentation

struct RArray rb_vm_struct::at_exit

Definition at line 328 of file vm_core.h.

Referenced by ruby_vm_run_at_exit_hooks(), and vm_init2().

VALUE rb_vm_struct::cmd

Definition at line 306 of file vm_core.h.

Referenced by rb_signal_exec(), rb_trap_exit(), rb_vm_mark(), and trap().

VALUE rb_vm_struct::coverages

Definition at line 316 of file vm_core.h.

Referenced by rb_vm_mark().

VALUE rb_vm_struct::debug

Definition at line 315 of file vm_core.h.

Referenced by ruby_vm_debug_ptr().

rb_event_hook_t* rb_vm_struct::event_hooks

Definition at line 311 of file vm_core.h.

Referenced by rb_add_event_hook(), rb_remove_event_hook(), rb_vm_mark(), and thread_exec_event_hooks().

rb_global_vm_lock_t rb_vm_struct::gvl

Definition at line 279 of file vm_core.h.

int rb_vm_struct::inhibit_thread_creation

Definition at line 288 of file vm_core.h.

Referenced by rb_thread_terminate_all().

st_table* rb_vm_struct::living_threads

Definition at line 284 of file vm_core.h.

Referenced by Init_VM(), rb_check_deadlock(), rb_thread_atfork_internal(), rb_thread_terminate_all(), rb_vm_mark(), ruby_vm_destruct(), thread_create_core(), thread_start_func_2(), vm_event_hooks_running_thread(), vm_living_thread_num(), and vm_memsize().

VALUE rb_vm_struct::load_path

Definition at line 300 of file vm_core.h.

Referenced by Init_load(), load_path_getter(), and rb_vm_mark().

VALUE rb_vm_struct::loaded_features

Definition at line 301 of file vm_core.h.

Referenced by Init_load(), rb_vm_bugreport(), and rb_vm_mark().

struct st_table* rb_vm_struct::loading_table

Definition at line 302 of file vm_core.h.

Referenced by rb_vm_mark().

struct rb_thread_struct* rb_vm_struct::main_thread

Definition at line 281 of file vm_core.h.

Referenced by Init_VM(), rb_check_deadlock(), rb_thread_atfork_internal(), rb_thread_kill(), rb_thread_terminate_all(), rb_threadptr_execute_interrupts_common(), rb_threadptr_signal_exit(), rb_threadptr_signal_raise(), ruby_vm_destruct(), thread_free(), thread_start_func_2(), and timer_thread_function().

VALUE rb_vm_struct::mark_object_ary

Definition at line 294 of file vm_core.h.

Referenced by Init_top_self(), and rb_vm_mark().

struct rb_objspace* rb_vm_struct::objspace

Definition at line 321 of file vm_core.h.

Referenced by Init_BareVM(), and ruby_vm_destruct().

VALUE rb_vm_struct::progname

Definition at line 315 of file vm_core.h.

Referenced by rb_vm_bugreport(), and vm_backtrace_each().

int rb_vm_struct::running

Definition at line 287 of file vm_core.h.

struct rb_thread_struct* rb_vm_struct::running_thread

Definition at line 282 of file vm_core.h.

Referenced by Init_VM(), and timer_thread_function().

int rb_vm_struct::safe

Definition at line 307 of file vm_core.h.

Referenced by rb_signal_exec(), rb_trap_exit(), and trap().

VALUE rb_vm_struct::self

Definition at line 277 of file vm_core.h.

Referenced by gc_marks(), Init_VM(), and ruby_vm_destruct().

volatile int rb_vm_struct::sleeper

Definition at line 291 of file vm_core.h.

Referenced by rb_check_deadlock(), rb_mutex_lock(), rb_thread_atfork_internal(), and sleep_forever().

VALUE rb_vm_struct::special_exceptions[ruby_special_error_count]

Definition at line 296 of file vm_core.h.

Referenced by rb_vm_mark(), and thread_fd_close_i().

int rb_vm_struct::src_encoding_index

Definition at line 313 of file vm_core.h.

Referenced by vm_init2().

VALUE rb_vm_struct::thgroup_default

Definition at line 285 of file vm_core.h.

Referenced by Init_Thread(), and rb_vm_mark().

int rb_vm_struct::thread_abort_on_exception

Definition at line 289 of file vm_core.h.

Referenced by thread_start_func_2().

VALUE rb_vm_struct::top_self

Definition at line 299 of file vm_core.h.

Referenced by Init_top_self(), and rb_vm_mark().

unsigned long rb_vm_struct::trace_flag

Definition at line 290 of file vm_core.h.

struct { ... } rb_vm_struct::trap_list[RUBY_NSIG]

Referenced by rb_signal_exec(), rb_trap_exit(), rb_vm_mark(), and trap().

struct unlinked_method_entry_list_entry* rb_vm_struct::unlinked_method_entry_list

Definition at line 318 of file vm_core.h.

Referenced by rb_gc_mark_unlinked_live_method_entries(), and rb_sweep_method_entry().

VALUE rb_vm_struct::verbose

Definition at line 315 of file vm_core.h.

Referenced by ruby_vm_verbose_ptr().

The documentation for this struct was generated from the following file:

- vm_core.h